<template>
	<view class="svBox" :style="config.height ? `height: ${config.height};` : 'height: 375rpx;'">
		<!-- 滚动 轮播 组件 -->

		<!-- s 背景块颜色 -->
		<view v-if="config.bg && config.bg.show" class="bgcolor"></view>
		<!-- e 背景块颜色 -->

		<!-- s 滚动主体 -->
		<swiper class="sView slider-swiper"
		  :style="config.swiperStyle ? styleobjTostring(config.swiperStyle) : ''"
			:indicator-dots="config.indicator_dots"
			:indicator-color="config.indicator_color || '#6e6e6e'"
			:indicator-active-color="config.indicator_active_color || '#FFFFFF'"
			:autoplay="config.autoplay"
			:interval="config.interval || 5000"
			:current="config.current || 0"
			:circular="config.circular || true"
			:vertical="config.vertical"
			:previous-margin="config.previous_margin || '0px'"
			:next-margin="config.next_margin || '0px'"
			@change="swiperChange"
		>
			<block v-for="(item, index) in config.swiperArr" :key="index">
				<swiper-item class="swip-item" >
					<image 
						:src="item.src" 
						mode="widthFill" 
						:data-item="item"
						:data-link="item.link" 
						:data-linkType="item.linkType"  
						:style="config.configimageStyle ? styleobjTostring(config.configimageStyle) : ''"
						:class="config.draw  ? swiperIndex == index ? 'active slide-image-draw' : 'eactive slide-image' : 'slide-i'"
						@click="imgClick"></image>
				</swiper-item>
			</block>
		</swiper>
		<!-- e 滚动主体 -->

		<!-- s 自定义指示点 -->
		<view v-if="config.dots" class="dots" :style="config.dots.bottom ? `bottom: ${config.dots.bottom}` : 'bottom: 16rpx'">
			<view>
				<view v-for="(item, index) in config.swiperArr" :key="index" :style="swiperIndex == index ? getDotsStyle(true) : getDotsStyle(false)"></view>
			</view>
		</view>
		<!-- e 自定义指示点 -->
	</view>
</template>

<script lang="ts">
	import {
		Vue,
		Component,
		Prop,
		Watch
	} from "vue-property-decorator";
	
	@Component({})
	export default class Scrollview extends Vue {

		private swiperIndex: number = 0

		private dots = {
			bottom: '16rpx',
			height: '4rpx',
			width: '10rpx',
			actionColor: '#FFFFFF',
			color: '#B5B5B5',
			radius: '2rpx',
			left: '8rpx'
		} as swiper.dotsM

		@Prop({
			// 父组件传递给子组件的数据类型
			type: Object,

			// 是否必填
			required: false,

			// 默认值， 如果传入的是 Object，则要 default: ()=>({}) 参数为函数
			default: () => ({
				height: '40vh',
				bg: {},
				swiperArr: [],
			})
		}) config!: swiper.configMod;

		// 点击图片进行跳转
		imgClick(e: any) {
			let {
				link
			} = e.target.dataset;
			// wx.navigateTo({
			// 	url: link
			// });
		}
		
		onLaunch(){
		}
		
		// style
		styleobjTostring(obj: any){
			let arr = []
			for(let key in obj){
				arr.push(`${key}: ${obj[key]}`)
			}
			return arr.join(';')
		}

		// swiperChange
		swiperChange(e: any) {
			this.swiperIndex = e.detail.current
		}

		// get dots style
		getDotsStyle(bool: boolean) {
			const arr = [] as string[]
			const cdots =  this.config.dots || this.dots
			arr.push(`width: ${cdots.width ? cdots.width : this.dots.width};`)
			arr.push(`min-height: ${cdots.height ? cdots.height : this.dots.height};`)
			arr.push(`margin-left: ${cdots.left ? cdots.left : this.dots.left};`)
			const color = bool ? cdots.actionColor ? cdots.actionColor : this.dots.actionColor : cdots.color ? cdots.color : this.dots.color  
			arr.push(`background-color: ${color};`)
			arr.push(`border-radius: ${cdots.radius ? cdots.radius : this.dots.radius}`)
			return arr.join('')
		}
	}
</script>

<style lang="scss" scoped>
	.dots{
		width: 750rpx;
		z-index: 1000;
		position: absolute;
		display: flex;
		justify-content: center;
		>view {
			display: flex;
			justify-content: center;
		}
	}
	.svBox {
		position: relative;
		width: 100vw;
	}

	@keyframes all {
		0% { height: 95%!important; z-index: 20; opacity: .5; }
		50% { height: 97%!important; z-index: 20; opacity: .7; }
		100% { height: 100%!important; z-index: 20; opacity: 1; }
	}
	@-webkit-keyframes all {
		0% { height: 95%!important; z-index: 20; opacity: .5; }
		50% { height: 97%!important; z-index: 20; opacity: .7; }
		100% { height: 100%!important; z-index: 20; opacity: 1; }
	}

	@keyframes end {
		0% { height: 100%!important; z-index: 20; opacity: 1; }
		50% { height: 97%!important; z-index: 20; opacity: .7; }
		100% { height: 95%!important; z-index: 20; opacity: 5; }
	}
	@-webkit-keyframes end {
		0% { height: 100%!important; z-index: 20; opacity: 1; }
		50% { height: 97%!important; z-index: 20; opacity: .7; }
		100% { height: 95%!important; z-index: 20; opacity: 5; }
	}
	
	.eactive {
		transition: end .4s ease-in 0s;
	}

	.active {
		transition: all .3s ease-in 0s;
	}

	.bgcolor {
		min-height: 60%;
		width: 100vw;
		background-color: #7FAE50;
		z-index: 1;
	}

	.sView {
		z-index: 2;
		min-height: 200rpx;
		height: 100%;
		width: 100%;
		position: absolute;
	}

	.swip-item {
		display: flex;
		align-items: center;
		border-radius: 2vw;
		width: 100%
	}

	.slide-i {
		border-radius: 2vw;
		overflow: hidden;
		height: 100%;
		width: 100%;
	}

	.slide-image {
		border-radius: 2vw;
		overflow: hidden;
		opacity: 0.5;
		height: 90%;
		width: 100%;
	}
	
	.slide-image-draw {
		border-radius: 2vw;
		overflow: hidden;
		opacity: 1;
		height: 100%;
		width: 100%;
	}
	
	.uni-swiper-dot {
    margin-right: 10px !important;
	}
</style>
